﻿using PdfSharp.Pdf;
using PdfSharp.Pdf.Content;
using PdfSharp.Pdf.IO;
using System;
using System.Collections.Generic;
using System.Text;

namespace PdfSharp.Testing
{
    class Program
    {
        static void Main(string[] args)
        {
        	// Some documents found on the PdfSharp Forum
        	
            // The 'startxref' Keyword does not point to the xref-table, throws an Exception now
            //var doc = PdfReader.Open("D:\\Code\\PdfSharp\\TestDocuments\\0001.pdf", PdfDocumentOpenMode.Modify);
            
            // Lexer.ReadStream fixed for the case of a SPACE following the Keyword 'stream'
            //var doc = PdfReader.Open("D:\\Code\\PdfSharp\\TestDocuments\\04-22-2010_TEST.pdf", PdfDocumentOpenMode.Modify);
            
            // Partly(?) decrypted document, contains invalid Strings, opens in Foxit, though
            //var doc = PdfReader.Open("D:\\Code\\PdfSharp\\TestDocuments\\o-neuro-untersuchung.decrypted.pdf", PdfDocumentOpenMode.Modify);

            // Standard RC4 Encryption
            //var doc = PdfReader.Open("D:\\Code\\PdfSharp\\TestDocuments\\o-neuro-untersuchung.pdf", PdfDocumentOpenMode.Import);

            // Fixed ASCIIHexDecode Filter and Filter.RemoveWhiteSpace for this
            //var doc = PdfReader.Open("D:\\Code\\PdfSharp\\TestDocuments\\SchHDPE_153 RAA.pdf", PdfDocumentOpenMode.Import);

            // Lexer.ScanNumber handles thousand-separator
            //var doc = PdfReader.Open("D:\\Code\\PdfSharp\\TestDocuments\\WrongMediaBox.pdf", PdfDocumentOpenMode.Import);

            var pages = doc.Pages;
            var mode = doc.PageMode;
            var page = pages[0];
            var cdata = ContentReader.ReadContent(page);

            var outDoc = new PdfDocument();
            outDoc.AddPage(page);
            outDoc.SecuritySettings.OwnerPassword = "password";
            outDoc.Save("D:\\Code\\PdfSharp\\TestDocuments\\out.pdf");
        }
    }
}
