﻿using PdfSharp.Pdf.IO;

namespace PdfSharp.Pdf.Security
{
    internal class EncryptorFactory
    {
        public static IEncryptor Create(PdfDocument doc, PdfDictionary dict)
        {
            IEncryptor encryptor;
            string filter = dict.Elements.GetName(PdfSecurityHandler.Keys.Filter);
            int v = dict.Elements.GetInteger(PdfSecurityHandler.Keys.V);
            if (filter != "/Standard" || !(v >= 1 && v <= 5))
                throw new PdfReaderException(PSSR.UnknownEncryption);
            if (v <= 3)
                encryptor = new RC4Encryptor();
            else
                encryptor = new AESEncryptor();
            encryptor.Initialize(doc, dict);
            return encryptor;
        }
    }
}
